---@type Tinkr
local Tinkr,
---@class Bastion
Bastion = ...

---@class Bastion.Missile : Tinkr.Missile
local Missile = {
}

function Missile:__index(k)
    if k == "_missile" then
        return rawget(self, k)
    end

    local response = rawget(self._missile, k)

    return response ~= nil and response or rawget(self, k)
end

---@param missile Tinkr.Missile
function Missile:New(missile)
    ---@class Bastion.Missile
    local self = setmetatable({
        _missile = missile
    }, Missile)
    return self
end

function Missile:GetSourceUnit()
    return Bastion.UnitManager:Get(self.source)
end

function Missile:GetTargetUnit()
    return Bastion.UnitManager:Get(self.target)
end

function Missile:GetCurrentVector()
    return Bastion.Vector3:New(self.cx, self.cy, self.cz)
end

function Missile:GetHitVector()
    return Bastion.Vector3:New(self.hx, self.hy, self.hz)
end

function Missile:GetInitialVector()
    return Bastion.Vector3:New(self.ix, self.iy, self.iz)
end

function Missile:GetModelVector()
    return Bastion.Vector3:New(self.mx, self.my, self.mz)
end

function Missile:GetPVector()
    return Bastion.Vector3:New(self.px, self.py, self.pz)
end

function Missile:GetUVector()
    return Bastion.Vector3:New(self.ux, self.uy, self.uz)
end

Bastion.Missile = Missile
